Index: mediaportal/Core/Player/FFDShow/Interfaces/IffdshowBase.cs
===================================================================
--- mediaportal/Core/Player/FFDShow/Interfaces/IffdshowBase.cs	(revision 0)
+++ mediaportal/Core/Player/FFDShow/Interfaces/IffdshowBase.cs	(revision 0)
@@ -0,0 +1,122 @@
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Runtime.InteropServices;
+using System.Security;
+
+namespace FFDShow.Interfaces
+{
+  [Guid("FC5BCCF4-FD62-45ee-B022-3840EAEA77B2"), SuppressUnmanagedCodeSecurity,
+  InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
+  public interface IffdshowBase
+  {
+    [PreserveSig]
+    int getVersion2();
+    [PreserveSig]
+    int getParam(uint paramID, out int value);
+    [PreserveSig]
+    System.Int32 getParam2(uint paramID);
+    [PreserveSig]
+    int putParam(uint paramID, int value);
+    [PreserveSig]
+    int invParam(uint paramID);
+    [PreserveSig]
+    int getParamStr(uint paramID, out IntPtr str, int buflen);
+    //int getParamStr(uint paramID, out string str, int buflen);
+    [PreserveSig]
+    [return:MarshalAs(UnmanagedType.LPWStr)] string getParamStr2(uint paramID); //returns const pointer to string, NULL if fail
+    [PreserveSig]
+    int putParamStr(uint paramID, [In, MarshalAs(UnmanagedType.LPWStr)] string str);
+    [PreserveSig]
+    int getParamName(uint i, out string str, int len);
+    int notifyParamsChanged();
+    int setOnChangeMsg(IntPtr wnd, uint msg);
+    int setOnFrameMsg(IntPtr wnd, uint msg);
+    int getGlobalSettings(IntPtr globalSettingsPtr);
+    int saveGlobalSettings();
+    int loadGlobalSettings();
+    int saveDialogSettings();
+    int loadDialogSettings();
+    //int getConfig(const Tconfig* *configPtr);
+    //int getInstance(HINSTANCE *hi);
+    //STDMETHOD_(HINSTANCE,getInstance2();
+    //int getPostproc(Tlibmplayer* *postprocPtr);
+    //int getTranslator(Ttranslate* *trans);
+    int getConfig(IntPtr configPtr);
+    int getInstance(IntPtr hi);
+    IntPtr getInstance2();
+    //int getPostproc(IntPtr postprocPtr); //Need to remove after r3603 change.
+    int getTranslator(IntPtr trans);
+
+    int initDialog();
+    int showCfgDlg(IntPtr owner);
+    int getCpuUsage2();
+    int getCpuUsageForPP();
+    int cpuSupportsMMX();
+    int cpuSupportsMMXEXT();
+    int cpuSupportsSSE();
+    int cpuSupportsSSE2();
+    int cpuSupportsSSE3();
+    int cpuSupportsSSSE3();
+    int cpuSupports3DNOW();
+    int cpuSupports3DNOWEXT();
+    int dbgInit();
+    int dbgError(string fmt, IntPtr args);
+    int dbgWrite(string fmt, IntPtr args);
+    int dbgDone();
+    int showTrayIcon();
+    int hideTrayIcon();
+    IntPtr getExeflnm();
+    int getLibavcodec(IntPtr libavcodecPtr);
+    IntPtr getSourceName();
+    int getGraph(IntPtr graphPtr);
+    int seek(int seconds);
+    int tell(out int seconds);
+    int stop();
+    int run();
+    int getState2();
+    int getCurTime2();
+    [PreserveSig]
+    int getParamStr3(uint paramID, out IntPtr bufPtr);
+    //int getParamStr3(uint paramID, [Out, MarshalAs(UnmanagedType.LPWStr)] out string bufPtr);
+   
+    //int savePresetMem(void *buf,int len); //if len=0, then buf should point to int variable which will be filled with required buffer length
+    //int loadPresetMem(const void *buf,int len);
+    int savePresetMem(IntPtr buf, int len); //if len=0, then buf should point to int variable which will be filled with required buffer length
+    int loadPresetMem(IntPtr buf, int len);
+    int getParamName3(uint i, out string namePtr);
+    int getInCodecString(out string str, int buflen);
+    int getOutCodecString(out string str, int buflen);
+    int getMerit(out double merit);
+    int setMerit(double merit);
+    int lock_(int lockId);
+    int unlock(int lockId);
+    int getParamInfo(uint i, IntPtr paramPtr);
+    int exportRegSettings(int all, string regflnm, int unicode);
+    int checkInputConnect(IntPtr pin);
+    int getParamListItem(int paramId, int index, IntPtr ptr);
+    int abortPlayback(int hr);
+    int notifyParam(int id, int val);
+    int notifyParamStr(int id, string val);
+    int doneDialog();
+    int resetParam(uint paramID);
+    int getCurrentCodecId2();
+    int frameStep(int diff);
+    int getInfoItem(uint index, out int id, out string name);
+    int getInfoItemValue(int id, out string value, out int wasChange, out int splitline);
+    int inExplorer();
+    IntPtr getInfoItemName(int id);
+    IntPtr getCfgDlgHwnd();
+    void setCfgDlgHwnd(IntPtr hwnd);
+    IntPtr getTrayHwnd_();
+    void setTrayHwnd_(IntPtr hwnd);
+    string getInfoItemShortcut(int id);
+    int getInfoShortcutItem(string s, out int toklen);
+    double CPUcount();
+    int get_trayIconType();
+    int cpuSupportsSSE41();
+    int cpuSupportsSSE42();
+    int cpuSupportsSSE4A();
+    int cpuSupportsSSE5();
+  };
+}
Index: mediaportal/Core/Player/FFDShow/Interfaces/IffdshowDec.cs
===================================================================
--- mediaportal/Core/Player/FFDShow/Interfaces/IffdshowDec.cs	(revision 0)
+++ mediaportal/Core/Player/FFDShow/Interfaces/IffdshowDec.cs	(revision 0)
@@ -0,0 +1,132 @@
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Runtime.InteropServices;
+using System.Security;
+
+namespace FFDShow.Interfaces
+{
+  [Guid("10F99065-70D5-4bcc-9D88-3801F3E3881B"), SuppressUnmanagedCodeSecurity,
+  InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
+  public interface IffdshowDec
+  {
+    int getVersion2();
+    int saveKeysSettings();
+    int loadKeysSettings();
+
+    //int getGraph(/*IFilterGraph*/IntPtr graphPtr);
+    int getGraph([Out, MarshalAs(UnmanagedType.Interface)] out object graphPtr);
+
+    int seek(int seconds);
+    int tell(out int seconds);
+    int stop();
+    int run();
+    int getState2();
+    int getDuration(out int seconds);
+    int getCurTime2();
+    int initKeys();
+    int getKeyParamCount2();
+    int getKeyParamDescr(uint i, out string descr);
+    int getKeyParamKey2(uint i);
+    int setKeyParamKey(uint i, int key);
+    int getNumPresets(out uint value);
+    int initPresets();
+    int getPresetName(uint i, string buf, int len);
+    int getActivePresetName(string buf, int len);
+    int setActivePreset(string name, int create);
+    int saveActivePreset(string name);
+    int saveActivePresetToFile(string flnm);
+    int loadActivePresetFromFile(string flnm);
+    int removePreset(string name);
+
+    //int getPresets(Tpresets *presets2);
+    //int setPresets(Tpresets *presets2);
+    int getPresets(object presets2);
+    int setPresets(object presets2);
+
+    int savePresets();
+
+    //int getPresetPtr(Tpreset**preset);
+    //int setPresetPtr(Tpreset *preset);
+    int getPresetPtr(object preset);
+    int setPresetPtr(object preset);
+
+    int renameActivePreset(string newName);
+    int isDefaultPreset(string presetName);
+    int createTempPreset(string presetName);
+    int getMinOrder2();
+    int getMaxOrder2();
+    int resetFilter(uint filterID);
+    int resetFilterEx(uint filterID, uint filterPageId);
+    int getFilterTip(uint filterID, string buf, int buflen);
+    int getFilterTipEx(uint filterID, uint filterPageId, string buf, int buflen);
+    int filterHasReset(uint filterID);
+    int filterHasResetEx(uint filterID, uint filterPageId);
+
+    //int getPresetsPtr(Tpresets* *presetsPtr);
+    //int newSample(IMediaSample* *samplePtr);
+    //int deliverSample_unused(IMediaSample *sample);
+    //STDMETHOD_(TfilterIDFF*,getFilterIDFF_notimpl();
+    int getPresetsPtr(object presetsPtr);
+    int newSample(object samplePtr);
+    int deliverSample_unused(object sample);
+
+    object getFilterIDFF_notimpl();
+    int resetOrder();
+    int resetKeys();
+    int putStringParams(string parameters, char sep, int loaddef);
+
+    //STDMETHOD_(TfilterIDFF*,getNextFilterIDFF();
+    object getNextFilterIDFF();
+
+    int cyclePresets(int step);
+    int exportKeysToGML(string flnm);
+    int getShortDescription(out string buf, int buflen);
+    string getActivePresetName2();
+
+    //int createPresetPages(string presetname,TffdshowPageDec *pages);
+    int createPresetPages(string presetname, object pages);
+
+    int getEncoderInfo(out string buf, int buflen);
+    string getDecoderName();
+
+    //int getFilterIDFFs(string presetname,TfilterIDFFs* *filters);
+    int getFilterIDFFs(string presetname, object filters);
+
+    int initRemote();
+    int saveRemoteSettings();
+    int loadRemoteSettings();
+    int setFilterOrder(uint filterID, uint newOrder);
+    uint getPresetAutoloadItemsCount2();
+    int getPresetAutoloadItemInfo(uint index, out string name, out string hint, out int allowWildcard, out int isL, out int isVal, string val, int vallen, out int isList, out int isHelp);
+    int setPresetAutoloadItem(uint index, int isL, string val);
+    string getPresetAutoloadItemList(uint paramIndex, uint listIndex);
+    string[] getSupportedFOURCCs();
+
+    //STDMETHOD_(Tstrptrs*,getCodecsList();
+    //int queryFilterInterface(IID &iid,void **ptr);
+    //int setOnNewFiltersMsg(IntPtr wnd,uint msg);
+    object getCodecsList();
+    int queryFilterInterface(out Guid iid, IntPtr[] ptr);
+    int setOnNewFiltersMsg(int wnd, uint msg);
+
+    int sendOnNewFiltersMsg();
+    int setKeyParamKeyCheck(uint i, int key, out int prev, out string prevDescr);
+    int getInputBitrate2();
+    int getPresetAutoloadItemHelp(uint index, out string helpPtr);
+
+    //STDMETHOD_(TinputPin*, getInputPin();
+    //STDMETHOD_(CTransformOutputPin*, getOutputPin();
+    object getInputPin();
+    object getOutputPin();
+
+    int extractExternalStreams();
+
+    //int getExternalStreams(void **pAudioStreams, void **pSubtitleStreams);
+    //int setExternalStream(int group, long streamNb);
+    int getExternalStreams(IntPtr[] pAudioStreams, IntPtr[] pSubtitleStreams);
+    int setExternalStream(int group, long streamNb);
+    int getCurrentSubtitlesFile([Out, MarshalAs(UnmanagedType.LPWStr)]out string ppSubtitleFile);
+    int setSubtitlesFile(string pSubtitleFile);
+  };
+}
Index: mediaportal/Core/Player/FFDShow/Interfaces/IffdshowDecVideo.cs
===================================================================
--- mediaportal/Core/Player/FFDShow/Interfaces/IffdshowDecVideo.cs	(revision 0)
+++ mediaportal/Core/Player/FFDShow/Interfaces/IffdshowDecVideo.cs	(revision 0)
@@ -0,0 +1,109 @@
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Runtime.InteropServices;
+
+namespace FFDShow.Interfaces
+{
+    [Guid("00F99064-70D5-4bcc-9D88-3801F3E3881B"),
+    InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
+    public interface IffdshowDecVideo
+    {
+        int getVersion2();
+        int getAVIdimensions(out uint x, out uint y);
+        int getAVIfps(out uint fps1000);
+        int getAVcodecVersion(out string buf, int len);
+        int getPPmode(out uint ppmode);
+        int getRealCrop(out uint left, out uint top, out uint right, out uint bottom);
+        int getXvidVersion(out string buf, int len);
+        //int getMovieSource(const TvideoCodecDec* *moviePtr);
+        int getOutputDimensions(out uint x, out uint y);
+        int getOutputFourcc(out string buf, int len);
+        int getInputBitrate2();
+        //int getHistogram (uint dst[256]);
+        int setFilterOrder(uint filterID, uint newOrder);
+        //int buildHistogram_(const TffPict *pict,int full);
+        int getAVIfps1000_2();
+        int getCurrentFrameTime(out uint sec);
+        //int getImgFilters_(void* *imgFiltersPtr);
+        //int getQuant(int* *quantPtr);
+        int calcNewSize(uint inDx, uint inDy, out uint outDx, out uint outDy);
+        int grabNow();
+        int getOverlayControlCapability(int idff); //S_OK - can be set, S_FALSE - not supported
+        //int lock(int lockId);
+        //int unlock(int lockId);
+        //int calcMeanQuant(float *quant);
+        int findAutoSubflnm2();
+        int getFrameTime(uint framenum, out uint sec);
+        int shortOSDmessage(string msg, uint duration); //duration is in frames
+        int cleanShortOSDmessages();
+        int shortOSDmessageAbsolute(string msg, uint duration, uint posX, uint posY); //duration is in frames
+        //int setImgFilters_(void *imgFiltersPtr);
+        int registerSelectedMediaTypes();
+        int getFrameTimes(out double start, out double stop);
+        int getSubtitleTimes(out double start, out double stop);
+        int resetSubtitleTimes();
+        int setFrameTimes(double start, double stop);
+        //int getCodecId(const BITMAPINFOHEADER *hdr,const GUID *subtype,FOURCC *AVIfourcc);
+        //int getFontManager(TfontManager* *fontManagerPtr);
+        int getInIsSync();
+        int getVideoWindowPos(out int left, out int top, out uint width, out uint height);
+        uint getSubtitleLanguagesCount2();
+        int getSubtitleLanguageDesc(uint num, [In, MarshalAs(UnmanagedType.LPWStr)] string descPtr);
+        //int fillSubtitleLanguages(IntPtr[] langs);
+        int getFrameTimeMS(uint framenum, out uint msec);
+        int getCurrentFrameTimeMS(out uint msec);
+        int frameStep(int diff);
+        int textPinConnected_(uint num);
+        int cycleSubLanguages(int diff);
+        //int getLevelsMap(uint map[256]);
+        IntPtr findAutoSubflnm3();
+        int setAverageTimePerFrame(out double avg, int useDef);
+        int getLate(out double latePtr);
+        int getAverageTimePerFrame(out double avg);
+        //string getEmbeddedSubtitleName2_(uint num);
+        //int putHistogram_(uint Ihistogram[256]);
+        String getCurrentSubFlnm(); // Does not work
+        int quantsAvailable();
+        int isNeroAVC_();
+        //int findOverlayControl(IMixerPinConfig2* *overlayPtr);
+        //int getVideoDestRect(RECT *r);
+        //FOURCC getMovieFOURCC();
+        int getRemainingFrameTime(out uint sec);
+        int getInputSAR(out uint a1, out uint a2);
+        int getInputDAR(out uint a1, out uint a2);
+        //int getQuantMatrices(unsigned char intra8[64],unsigned char inter8[64]);
+        //string findAutoSubflnms(IcheckSubtitle *checkSubtitle);
+        int addClosedCaption(string line);
+        int hideClosedCaptions();
+        int getConnectedTextPinCnt();
+        //int getConnectedTextPinInfo(int i,const tchar* *name,int *id,int *found);
+        //int getConnectedTextPinInfo(int i,const tchar* *trackName, const tchar* *langName,int *id,int *found);
+        //int registerOSDprovider(IOSDprovider *provider,const char *name);
+        //int unregisterOSDprovider(IOSDprovider *provider);
+        //int findOverlayControl2(IhwOverlayControl* *overlayPtr);
+        int getOSDtime();
+        int getQueuedCount();
+        double getLate();
+        IntPtr get_current_idct();
+        int get_time_on_ffdshow();
+        int get_time_on_ffdshow_percent();
+        int shouldSkipH264loopFilter();
+        int get_downstreamID();
+        IntPtr getAviSynthInfo();
+        int lockCSReceive();
+        int unlockCSReceive();
+        //STDMETHOD_(ToutputVideoSettings*,getToutputVideoSettings();
+        int getBordersBrightness();
+        int getChaptersList(IntPtr[] ppChaptersList);
+        int get_CurrentTime(out double time);
+        //const Trect*,getDecodedPictdimensions();
+        //HANDLE getGlyphThreadHandle();
+        IntPtr getRateInfo();
+        //int lock_csCodecs_and_imgFilters();
+        //int unlock_csCodecs_and_imgFilters();
+        //STDMETHOD_(void*, get_csReceive_ptr();
+        //STDMETHOD_(void*, get_csCodecs_and_imgFilters_ptr();
+        //int reconnectOutput(const TffPict &newpict);
+    };
+}
Index: mediaportal/Core/Player/g_player.cs
===================================================================
--- mediaportal/Core/Player/g_player.cs	(revision 26873)
+++ mediaportal/Core/Player/g_player.cs	(working copy)
@@ -37,6 +37,7 @@
 using Un4seen.Bass.AddOn.Cd;
 
 using Action = MediaPortal.GUI.Library.Action;
+using MediaPortal.Player.Subtitles;
 
 namespace MediaPortal.Player
 {
@@ -2262,6 +2263,24 @@
     }
     #endregion
 
+    #region Postprocessing selection
+    /// <summary>
+    /// Property which returns true if the player is able to perform postprocessing features
+    /// </summary>
+    public static bool HasPostprocessing
+    {
+      get
+      {
+        if (_player == null)
+        {
+          return false;
+        }
+        return _player.HasPostprocessing;
+      }
+    }
+    #endregion
+
+
     #region subtitle/audio stream selection
 
     /// <summary>
@@ -2344,8 +2363,33 @@
       }
     }
 
+    public static string[] SubtitleFiles
+    {
+      get
+      {
+        if (_player == null) return new string[] { };
+        return _player.SubtitleFiles;
+      }
+    }
+
+    public static string SubtitleFile
+    {
+      get
+      {
+        if (_player == null) return null;
+        return _player.SubtitleFile;
+      }
+      set
+      {
+        if (_player == null) return;
+        _player.SubtitleFile = value;
+      }
+    }
+    
+
     /// <summary>
     /// Property to get/set the current subtitle stream
+    /// Returns -1 if no subtitle stream is active
     /// </summary>
     public static int CurrentSubtitleStream
     {
@@ -2380,6 +2424,22 @@
       return Util.Utils.TranslateLanguageString(stream);
     }
 
+    /// <summary>
+    /// Retrieves the name of the subtitle stream
+    /// </summary>
+    /// <param name="iStream">Index of the stream</param>
+    /// <returns>Name of the track</returns>
+    public static string SubtitleName(int iStream)
+    {
+      if (_player == null)
+      {
+        return null;
+      }
+
+      string stream = _player.SubtitleName(iStream);
+      return Util.Utils.TranslateLanguageString(stream);
+    }
+
     #endregion
 
     public static bool EnableSubtitle
@@ -2576,6 +2636,20 @@
       }
     }
 
+    //}
+
+    /// <summary>
+    /// Switches to the next subtitle stream or file
+    /// </summary>
+    public static void SwitchToNextSubtitleSub()
+    {
+      if (_player != null)
+        SubEngine.GetInstance().SwitchToNextSubtitleSub();
+    }
+
+    /// <summary>
+    /// Switches to the next subtitle stream TV
+    /// </summary>
     public static void SwitchToNextSubtitle()
     {
       if (EnableSubtitle)
Index: mediaportal/Core/Player/IPlayer.cs
===================================================================
--- mediaportal/Core/Player/IPlayer.cs	(revision 26873)
+++ mediaportal/Core/Player/IPlayer.cs	(working copy)
@@ -24,6 +24,7 @@
 using MediaPortal.GUI.Library;
 
 using Action = MediaPortal.GUI.Library.Action;
+using MediaPortal.Player.Subtitles;
 
 namespace MediaPortal.Player
 {
@@ -523,6 +524,20 @@
     }
 
     /// <summary>
+    /// Property to get the total number of subtitle files
+    /// </summary>
+    public virtual string[] SubtitleFiles
+    {
+        get { return new string[] {}; }
+    }
+
+    public virtual string SubtitleFile
+    {
+        get { return null; }
+        set { }
+    }
+
+    /// <summary>
     /// Property to get/set the current subtitle stream
     /// </summary>
     public virtual int CurrentSubtitleStream
@@ -532,7 +547,7 @@
     }
 
     /// <summary>
-    /// Property to get/set the name for a subtitle stream
+    /// Property to get/set the language name for a subtitle stream
     /// </summary>
     public virtual string SubtitleLanguage(int iStream)
     {
@@ -540,6 +555,14 @@
     }
 
     /// <summary>
+    /// Property to get the name for a subtitle stream
+    /// </summary>
+    public virtual string SubtitleName(int iStream)
+    {
+      return null;
+    }
+
+    /// <summary>
     /// Property to get chapters
     /// </summary>
     public virtual double[] Chapters
@@ -665,8 +688,18 @@
       return false;
     }
 
-    public virtual void OnZapping(int info) { }    
+    public virtual void OnZapping(int info) { }
 
+    #region Posprocessing features
+    public virtual bool HasPostprocessing
+    {
+      get
+      {
+        return false;
+      }
+    }
+    #endregion
+
     #region IDisposable Members
 
     public abstract void Dispose();   

Index: mediaportal/Core/Player/PostProcessing/PostProcessingEngine.cs
===================================================================
--- mediaportal/Core/Player/PostProcessing/PostProcessingEngine.cs	(revision 0)
+++ mediaportal/Core/Player/PostProcessing/PostProcessingEngine.cs	(revision 0)
@@ -0,0 +1,87 @@
+#region Copyright (C) 2005-2010 Team MediaPortal
+
+// Copyright (C) 2005-2010 Team MediaPortal
+// http://www.team-mediaportal.com
+// 
+// MediaPortal is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 2 of the License, or
+// (at your option) any later version.
+// 
+// MediaPortal is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+// GNU General Public License for more details.
+// 
+// You should have received a copy of the GNU General Public License
+// along with MediaPortal. If not, see <http://www.gnu.org/licenses/>.
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using DirectShowLib;
+using System.Drawing;
+using MediaPortal.Profile;
+using MediaPortal.Configuration;
+using MediaPortal.Player.Subtitles;
+
+namespace MediaPortal.Player.PostProcessing
+{
+  public interface IPostProcessingEngine
+  {
+    bool HasPostProcessing { get; }
+    bool EnableResize { get; set; }
+    bool EnablePostProcess { get; set; }
+    bool EnableDeinterlace { get; set; }
+    bool EnableCrop { get; set; }
+    bool LoadPostProcessing(IGraphBuilder graphBuilder);
+    int CropVertical { get; set; }
+    int CropHorizontal { get; set; }
+  }
+
+  public class PostProcessingEngine
+  {
+    public static IPostProcessingEngine engine;
+
+    public static IPostProcessingEngine GetInstance()
+        {
+        return GetInstance(false);
+        }
+
+      public static IPostProcessingEngine GetInstance(bool forceinitialize)
+      {
+          if (engine == null || forceinitialize)
+          
+          {
+              /*public static IPostProcessingEngine GetInstance()
+              { */
+              using (Settings xmlreader = new MPSettings())
+              {
+                  /*string engineType = xmlreader.GetValueAsString("postprocessing", "engine", "FFDShow");
+                  if (engineType.Equals("FFDShow"))
+                      engine = new FFDShowEngine();
+                  else
+                      engine = new DummyEngine();*/
+                  engine = new FFDShowEngine();
+              }
+          }
+              return engine;
+       }
+
+    public class DummyEngine : IPostProcessingEngine
+    {
+      #region IPostProcessingEngine Members
+      public bool HasPostProcessing { get { return false; } }
+      public bool EnableResize { get { return false; } set { } }
+      public bool EnablePostProcess { get { return false; } set { } }
+      public bool LoadPostProcessing(IGraphBuilder graphBuilder) { return false; }
+      public bool EnableDeinterlace { get { return false; } set { } }
+      public bool EnableCrop { get { return false; } set { } }
+      public int CropVertical { get { return 0; } set { } }
+      public int CropHorizontal { get { return 0; } set { } }
+      #endregion
+    }
+  }
+}
Index: mediaportal/Core/Player/Subtitles/DirectVobSubEngine.cs
===================================================================
--- mediaportal/Core/Player/Subtitles/DirectVobSubEngine.cs	(revision 26873)
+++ mediaportal/Core/Player/Subtitles/DirectVobSubEngine.cs	(working copy)
@@ -179,6 +179,12 @@
       return streamName;
     }
 
+    public string GetSubtitleName(int iStream)
+    {
+        string languageTranslated = "";
+        return languageTranslated;
+    }
+
     public int Current
     {
       get { return current; }
@@ -226,6 +232,26 @@
       }
     }
 
+    public void SwitchToNextSubtitleSub()
+    {
+        if (Enable)
+        {
+            if (Current < GetCount() - 1)
+            {
+                Current++;
+            }
+            else
+            {
+                Enable = false;
+            }
+        }
+        else
+        {
+            Current = 0;
+            Enable = true;
+        }
+    }
+
     public int DelayInterval
     {
       get { return delayInterval; }
@@ -253,7 +279,12 @@
     }
 
     public void SetTime(long nsSampleTime) {}
+
+    #region Subtitle files
+    public string[] GetSubtitleFiles() { return new string[] { }; }
+    public string CurrentSubtitleFile { get { return null; } set { } }
     #endregion
+    #endregion
   }
 
   public class DirectVobSubUtil
@@ -296,8 +327,10 @@
       // Check if Haali Media Splitter is in the graph.
       IBaseFilter hms = null;
       DirectShowUtil.FindFilterByClassID(graphBuilder, ClassId.HaaliGuid, out hms);
-      if(hms == null)
+      if (hms == null)
         DirectShowUtil.FindFilterByClassID(graphBuilder, ClassId.MPCMatroska, out hms);
+      if (hms == null)
+        DirectShowUtil.FindFilterByClassID(graphBuilder, ClassId.MPCMatroskaSource, out hms);
       if (hms != null)
       {
         IPin pinSubTo = null;
Index: mediaportal/Core/Player/Subtitles/MpcEngine.cs
===================================================================
--- mediaportal/Core/Player/Subtitles/MpcEngine.cs	(revision 26873)
+++ mediaportal/Core/Player/Subtitles/MpcEngine.cs	(working copy)
@@ -155,6 +155,11 @@
       return MpcSubtitles.GetLanguage(i);
     }
 
+    public string GetSubtitleName(int i)
+    {
+      return MpcSubtitles.GetLanguage(i);
+    }
+
     public int Current
     {
       get { return MpcSubtitles.GetCurrent(); }
@@ -193,7 +198,31 @@
       MpcSubtitles.SetTime(nsSampleTime);
     }
 
+    public void SwitchToNextSubtitleSub()
+    {
+        if (Enable)
+        {
+            if (Current < GetCount() - 1)
+            {
+                Current++;
+            }
+            else
+            {
+                Enable = false;
+            }
+        }
+        else
+        {
+            Current = 0;
+            Enable = true;
+        }
+    }
+
+    #region Subtitle files
+    public string[] GetSubtitleFiles() { return new string[] { }; }
+    public string CurrentSubtitleFile { get { return null; } set { } }
     #endregion
+    #endregion
 
     private class MpcSubtitles
     {
@@ -227,6 +256,10 @@
       public static extern string GetLanguage(int i);
 
       [DllImport("mpcSubs.dll", ExactSpelling = true)]
+      [return: MarshalAs(UnmanagedType.BStr)]
+      public static extern string GetSubtitleName(int i);
+
+      [DllImport("mpcSubs.dll", ExactSpelling = true)]
       public static extern int GetCurrent();
 
       [DllImport("mpcSubs.dll", ExactSpelling = true)]
Index: mediaportal/Core/Player/Subtitles/SubEngine.cs
===================================================================
--- mediaportal/Core/Player/Subtitles/SubEngine.cs	(revision 26873)
+++ mediaportal/Core/Player/Subtitles/SubEngine.cs	(working copy)
@@ -44,12 +44,21 @@
     ////
     //subs management functions
     ///
+    #region Embedded subtitles
     int GetCount();
 
     string GetLanguage(int i);
 
+    string GetSubtitleName(int i);
+
     int Current { get; set; }
+    #endregion
 
+    #region Subtitle files
+    string[] GetSubtitleFiles();
+    string CurrentSubtitleFile { get; set; }
+    #endregion
+
     bool Enable { get; set; }
 
     int Delay { get; set; }
@@ -58,31 +67,40 @@
 
     void DelayPlus();
     void DelayMinus();
+
+    void SwitchToNextSubtitleSub();
   }
 
   public class SubEngine
-  {
-    private static ISubEngine engine;
+  { 
+    public static ISubEngine engine;
 
     public static ISubEngine GetInstance()
-    {
-      if (engine == null)
-      {
-        using (Settings xmlreader = new MPSettings())
         {
+        return GetInstance(false);
+        }
+
+      public static ISubEngine GetInstance(bool forceinitialize)
+        {
+        if (engine == null || forceinitialize)
+     {
+            using (Settings xmlreader = new MPSettings())
+        {
           string engineType = xmlreader.GetValueAsString("subtitles", "engine", "DirectVobSub");
           if (engineType.Equals("MPC-HC"))
             engine = new MpcEngine();
+          else if (engineType.Equals("FFDShow"))
+            engine = new FFDShowEngine();
           else if (engineType.Equals("DirectVobSub"))
             engine = new DirectVobSubEngine();
           else
             engine = new DummyEngine();
         }
-      }
+      }  
       return engine;
     }
 
-    private class DummyEngine : ISubEngine
+    public class DummyEngine : ISubEngine
     {
       #region ISubEngine Members
 
@@ -120,12 +138,24 @@
         return null;
       }
 
+      public string GetSubtitleName(int i)
+      {
+        return "";
+      }
+
       public int Current
       {
         get { return -1; }
         set { }
       }
 
+      public void SwitchToNextSubtitleSub() { }
+
+      #region Subtitle files
+      public string[] GetSubtitleFiles() { return new string[] { }; }
+      public string CurrentSubtitleFile { get { return null; } set { } }
+      #endregion
+
       public bool Enable
       {
         get { return false; }
Index: mediaportal/Core/Player/TSReaderPlayer.cs
===================================================================
--- mediaportal/Core/Player/TSReaderPlayer.cs	(revision 26873)
+++ mediaportal/Core/Player/TSReaderPlayer.cs	(working copy)
@@ -30,6 +30,7 @@
 using MediaPortal.Player.Subtitles;
 using MediaPortal.Player.Teletext;
 using MediaPortal.Profile;
+using MediaPortal.Player.PostProcessing;
 
 namespace MediaPortal.Player
 {
@@ -354,6 +355,21 @@
 
         #endregion
 
+        #region PostProcessingEngine Detection return on DummyEngine if False
+        //This is Sebastiii unsupported release version by Chemelli
+        string tmpstr;
+        IPostProcessingEngine postengine = PostProcessingEngine.GetInstance(true);
+        if (!postengine.LoadPostProcessing(_graphBuilder))
+        {
+          tmpstr = postengine.ToString().Substring(postengine.ToString().LastIndexOf(".") + 1);
+          Log.Error("TSReaderPlayer: {0} postprocessing configured in MP but misconfigured!", tmpstr);
+          PostProcessingEngine.engine = new PostProcessingEngine.DummyEngine();
+        }
+        //End This is Sebastiii unsupported release version by Chemelli
+        #endregion
+
+
+
         #region render TsReader output pins
 
         Log.Info("TSReaderPlayer: Render TsReader outputs");
@@ -784,6 +800,17 @@
     }
 
     /// <summary>
+    /// Property to Get Postprocessing
+    /// </summary>
+    public override bool HasPostprocessing
+    {
+      get
+      {
+        return PostProcessingEngine.GetInstance().HasPostProcessing;
+      }
+    }
+
+    /// <summary>
     /// Property to specify channel change
     /// </summary>
     public override void OnZapping(int info)
